/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/**
 * 
 */
package com.sos.localization;

import java.util.Locale;

/**
 * @author JS
 *
 */
public class SOSMsg {

	private final String	conClassName			= "SOSMsg";

	protected String		strMessageCode			= null;
	protected Messages		Messages				= null;
	protected boolean		flgFullMessageReported	= false;
	public static boolean	flgShowFullMessageText	= false;
	protected String		strLastMsgKey			= "";
	protected String		strControlName			= "";
	protected String		strControlParent		= "";

	/**
	 * 
	 */
	public SOSMsg(final String pstrMessageCode) {
		strMessageCode = pstrMessageCode;
	}

	public String label() {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::label";
		String key = strMessageCode.trim().replaceAll(" ", "");
		try {
			strLastMsgKey = key;
			String msg = Messages.getLabel(key.toLowerCase() + ".label");
			if (msg == null) {
				msg = Messages.getLabel(key + ".label");
				if (msg == null) {
					msg = Messages.getLabel(key);
				}
			}
			String strR = "";
			// if (msg != null && msg.equals("") == false) {
			if (msg != null) {
				strR = msg;
			}
			else {
				strR = key;
			}
			return strR;
		}
		catch (Exception e) {
			return strMessageCode;
		}
	}

	public String tooltip() {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::tooltip";
		try {
			strLastMsgKey = strMessageCode;
			String msg = Messages.getTooltip("tooltip." + strMessageCode.toLowerCase());
			if (msg == null) {
				msg = Messages.getLabel(strMessageCode.toLowerCase() + ".tooltip");
			}
			if (msg == null) {
				msg = Messages.getLabel(strMessageCode + ".tooltip");
			}

			// return (msg != null && !msg.equals("")) ? msg : strMessageCode;
			if (msg != null) {
				if (msg.trim().equals("none")) {
					msg = strMessageCode + ": sorry, no tooltip available yet";
				}
			}
			// else {
			// msg = strMessageCode + ": sorry, no tooltip available";
			// }

			String strLoc = strControlParent + "." + strControlName;
			if (strLoc.equals(".") == false) {
				msg = strLoc + " -> " + msg;
			}
			return msg;
		}
		catch (Exception e) {
			return strMessageCode;
		}
	}

	public String getF1() {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getF1";
		String key = strMessageCode.trim().replaceAll(" ", "");
		try {
			// strLastMsgKey = key;
			String msg = Messages.getLabel(key.toLowerCase() + ".f1");
			if (msg == null) {
				msg = Messages.getLabel(key.toLowerCase() + ".f1");
				if (msg == null) {
					msg = Messages.getLabel(key);
				}
			}
			return msg != null && !msg.equals("") ? msg : key;
		}
		catch (Exception e) {
			return strMessageCode;
		}
	}

	public String get() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::get";
		String strT = "";

		if (flgFullMessageReported == false) {
			strT = getFullMessage();
		}
		else {
			strT = Messages.getMsg(strMessageCode);
		}
		return strT;

	} // private String get

	public String get(final Exception pobjEx) {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::get";
		String strT = "";
		String strM = pobjEx.getLocalizedMessage();
		if (flgFullMessageReported == false) {
			strT = getFullMessage();
		}
		else {
			strT = Messages.getMsg(strMessageCode, strM);
		}
		return strT;

	} // private String get

	public String getFullMessage() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getFullMessage";

		String strT = "";
		String strMsgText = Messages.getMsg(strMessageCode);
		if (flgShowFullMessageText == false) {
			strT = strMsgText;
		}
		else {
			String strMsgAction = Messages.getLabel(strMessageCode + ".action");
			String strMsgDesc = Messages.getLabel(strMessageCode + ".description");
			if (strMsgDesc == null) {
				strMsgDesc = "*** no detailed description available ***";
			}
			String strMsgReason = Messages.getLabel(strMessageCode + ".reason");
			if (strMsgReason == null) {
				strMsgReason = "*** no detailed explanation available ***";
			}

			strT = strMsgText + "\n\n" + "DESCRIPTION" + "\n" + strMsgDesc + "\n\n" + "REASON" + "\n" + strMsgReason;
			flgFullMessageReported = true;
		}
		return strT;
	} // private String get

	public String get(final Object... pstrArgs) {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::get";

		return Messages.getMsg(strMessageCode, pstrArgs);

	} // private String get

	 public String params(final Object... pstrArgs) {
	
	 @SuppressWarnings("unused")
	 final String conMethodName = conClassName + "::params";
	
	 return Messages.getMsg(strMessageCode, pstrArgs);
	
	 } // private String get

//	public String params(final Object... pstrArgs) {
//
//		@SuppressWarnings("unused")
//		final String conMethodName = conClassName + "::params";
//
//		String msg = Messages.getLabel(strMessageCode.toLowerCase() + ".label");
//		if (msg == null) {
//			msg = Messages.getLabel(strMessageCode + ".label");
//		}
//		if (msg != null) {
//			msg = String.format(msg, pstrArgs);
//		}
//		else {
////			msg = Messages.getMsg(strMessageCode.toLowerCase());
//			msg = Messages.getMsg(strMessageCode);
//			if (msg == null) {
//				msg = Messages.getMsg(strMessageCode);
//				if (msg == null) {
//					msg = Messages.getMsg(strMessageCode);
//				}
//			}
//		}
//
//		return msg;
//
//	} // private String get

	public String paramsNoKey(final Object... pstrArgs) {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::paramsNoKey";

		return String.format(Messages.getLabel(strMessageCode), pstrArgs);

	} // private String get

	protected void setMessageResource(final String pstrResourceBundleName) {
		String strSOSLocale = System.getenv("SOS_LOCALE");
		if (strSOSLocale == null) {
			Messages = new Messages(pstrResourceBundleName, Locale.getDefault());
		}
		else {
			Messages = new Messages(pstrResourceBundleName, new Locale(strSOSLocale));
		}
	}

}
