/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: z_windows_event.h 11394 2005-04-03 08:30:29Z jz $

#ifndef __ZSCHIMMER_WINDOWS_EVENT_H
#define __ZSCHIMMER_WINDOWS_EVENT_H

#ifdef Z_WINDOWS

#include "threads_base.h"
#include "z_windows.h"

namespace zschimmer {
namespace windows {

//--------------------------------------------------------------------------------------------Event

struct Event : zschimmer::Event_base, Handle
{
                                Event                       ( const string& name = "" );
                                Event                       ( Dont_create, const string& name = "" ): Handle(NULL), _zero_(this+1), zschimmer::Event_base(name), _mutex( "Event " + name) {}
                                Event                       ( HANDLE h, const string& name = "" )   : Handle(h   ), _zero_(this+1), zschimmer::Event_base(name), _mutex( "Event " + name) {}
                               ~Event                       ();

    Event&                      operator =                  ( const HANDLE& h )                     { assert( _handle==NULL ); _handle = h; }

    void                        create                      ();
    virtual void                close                       ()                                      { Handle::close(); }

  //void                        set_signal                  ();
    void                        signal                      ( const string& name );
    void                        async_signal                ( const char* name );
    bool                        signaled_then_reset         ();
    void                        reset                       ();
    bool                        wait                        ( double seconds = INT_MAX );
  //void                        lock                        ();
  //void                        unlock                      ();
    bool                        valid                       () const                                { return Handle::valid(); }


    Fill_zero                  _zero_;
    Mutex                      _mutex;
};

//-----------------------------------------------------------------------------------windows::Events

/*
struct Events : Non_cloneable
{
                                Events                      ();
                               ~Events                      ();

    void                        add                         ( Event* );
    void                        remove                      ( Event* );
  //HANDLE                      operator []                 ( int index )                           { return _handles[index]; }
    int                         wait_until_localtime        ( double local_time );
    int                         wait_until_gmtime           ( double time );


    Fill_zero_                 _zero_;
    vector<Event*>             _events;
    pthread_cond_t             _pthread_cond;
    pthread_mutex_t            _pthread_mutex;
};
*/

//-------------------------------------------------------------------------------------------------

} //namespace windows
} //namespace zschimmer

#endif
#endif
